// Listing 3.4: Funktion zum ndern des Hostname eines Trust-Objekts
// abgeleitet aus Listing 2 aus [Appl_13.16]

SecTrustRef changeHostForTrust(SecTrustRef trust) 
{
    // TLS-Policy-Objekt fr den gewnschten Hostname anlegen
    CFMutableArrayRef newTrustPolicies = CFArrayCreateMutable(kCFAllocatorDefault, 0, &kCFTypeArrayCallBacks);
    SecPolicyRef sslPolicy = SecPolicyCreateSSL(true, CFSTR("www.der-hostname.example"));
    
    CFArrayAppendValue(newTrustPolicies, sslPolicy);
    
    // Ein neues Array fr die Zertifikate anlegen
    CFMutableArrayRef certificates = CFArrayCreateMutable(kCFAllocatorDefault, 0, &kCFTypeArrayCallBacks);
    
    // Zertifikate des originalen Trust-Objekts kopieren
    CFIndex count = SecTrustGetCertificateCount(trust);
    CFIndex i=0;
    for (i = 0; i < count; i++) {
        SecCertificateRef item = SecTrustGetCertificateAtIndex(trust, i);
        CFArrayAppendValue(certificates, item);
    }

    
    // Ein neues Trust-Objekt anlegen und die Zertifikate hinein kopieren
    SecTrustRef newtrust = NULL;
    if (SecTrustCreateWithCertificates(certificates, newTrustPolicies, &newtrust) != errSecSuccess) {
        // Hier wre eine Fehlermeldung oder ein Eintrag im Logfile 
        // angebracht 
        return NULL;
    }  
    
    // Das neue Trust-Objekt mit dem genderten Hostname zurckgeben
    return newtrust;
}
